<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "idp_provision_operation".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "IdpProvisionOperation".
 *
 * Columns in table "idp_provision_operation" available as properties of the model,
 * followed by relations of table "idp_provision_operation" available as properties of the model.
 *
 * @property integer $id
 * @property integer $idp_provision_verb_id
 * @property integer $sort_order
 * @property string $model_name
 * @property string $model_operation
 * @property string $component_name
 * @property string $component_function
 * @property integer $idp_provision_operation_id
 * @property string $enrich_query
 * @property string $mapping
 * @property integer $enabled
 * @property string $date_added
 * @property string $date_updated
 *
 * @property IdpProvisionOperation $idpProvisionOperation
 * @property IdpProvisionOperation[] $idpProvisionOperations
 * @property IdpProvisionVerb $idpProvisionVerb
 * @property IdpProvisionOperationCondition[] $idpProvisionOperationConditions
 * @property IdpResultLog[] $idpResultLogs
 */
abstract class BaseIdpProvisionOperation extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'idp_provision_operation';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'IdpProvisionOperation|IdpProvisionOperations', $n);
    }

    public static function representingColumn()
    {
        return 'model_name';
    }

    public function rules()
    {
        return array(
            array('idp_provision_verb_id, sort_order, model_name, model_operation, component_name, component_function, enrich_query, mapping, date_added, date_updated', 'required'),
            array('idp_provision_verb_id, sort_order, idp_provision_operation_id, enabled', 'numerical', 'integerOnly'=>true),
            array('model_name', 'length', 'max'=>40),
            array('model_operation', 'length', 'max'=>6),
            array('component_name, component_function', 'length', 'max'=>60),
            array('idp_provision_operation_id, enabled', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, idp_provision_verb_id, sort_order, model_name, model_operation, component_name, component_function, idp_provision_operation_id, enrich_query, mapping, enabled, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'idpProvisionOperation' => array(self::BELONGS_TO, 'IdpProvisionOperation', 'idp_provision_operation_id'),
            'idpProvisionOperations' => array(self::HAS_MANY, 'IdpProvisionOperation', 'idp_provision_operation_id'),
            'idpProvisionVerb' => array(self::BELONGS_TO, 'IdpProvisionVerb', 'idp_provision_verb_id'),
            'idpProvisionOperationConditions' => array(self::HAS_MANY, 'IdpProvisionOperationCondition', 'idp_provision_operation_id'),
            'idpResultLogs' => array(self::HAS_MANY, 'IdpResultLog', 'idp_provision_operation_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'idp_provision_verb_id' => null,
            'sort_order' => Yii::t('app', 'Sort Order'),
            'model_name' => Yii::t('app', 'Model Name'),
            'model_operation' => Yii::t('app', 'Model Operation'),
            'component_name' => Yii::t('app', 'Component Name'),
            'component_function' => Yii::t('app', 'Component Function'),
            'idp_provision_operation_id' => null,
            'enrich_query' => Yii::t('app', 'Enrich Query'),
            'mapping' => Yii::t('app', 'Mapping'),
            'enabled' => Yii::t('app', 'Enabled'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'idpProvisionOperation' => null,
            'idpProvisionOperations' => null,
            'idpProvisionVerb' => null,
            'idpProvisionOperationConditions' => null,
            'idpResultLogs' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('idp_provision_verb_id', $this->idp_provision_verb_id);
        $criteria->compare('sort_order', $this->sort_order);
        $criteria->compare('model_name', $this->model_name, true);
        $criteria->compare('model_operation', $this->model_operation, true);
        $criteria->compare('component_name', $this->component_name, true);
        $criteria->compare('component_function', $this->component_function, true);
        $criteria->compare('idp_provision_operation_id', $this->idp_provision_operation_id);
        $criteria->compare('enrich_query', $this->enrich_query, true);
        $criteria->compare('mapping', $this->mapping, true);
        $criteria->compare('enabled', $this->enabled);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
